/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.servlets;

import com.supinfo.spitfireboard.entities.User;
import com.supinfo.spitfireboard.services.UserService;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 *
 * @author Fabien LOISON
 */
@ManagedBean
@RequestScoped
public class RegisterController {
    
    @EJB
    private UserService userService;

    /**
     * Creates a new instance of RegisterController
     */
    public RegisterController() {
    }
    
    private String getValue(String fieldName) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        return (String) facesContext.getExternalContext().getRequestParameterMap().get(fieldName);
    }
    
    public List<String> doRegister() {
        List<String> errors = new ArrayList<String>();
        
        // Check for empty fields
        if (this.getValue("username").equals("")) {
            errors.add("The 'Username' field is empty");
        }
        if (this.getValue("email").equals("")) {
            errors.add("The 'E-mail' field is empty");
        }
        if (this.getValue("password").equals("")) {
            errors.add("The 'Password' field is empty");
        }
        if (this.getValue("password2").equals("")) {
            errors.add("The 'Password (check)' field is empty");
        }
        
        // Check if both passwords are equal
        if (! this.getValue("password").equals(this.getValue("password2"))) {
            errors.add("The two passwords are not equal.");
        }
        
        // No error...
        if (errors.isEmpty()) {
            
            // Check if user already exists
            if (userService.userExists(this.getValue("username"))) {
                errors.add("An user with the same username is already registered.");
                return errors;
            }
            
            // DB Insert
            try {
                userService.newUser(
                        this.getValue("username"),
                        this.getValue("email"),
                        this.getValue("password"));
            }
            catch (Exception ex) {
                errors.add("Oops! Something wrong appened.");
                return errors;
            }
            
            ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
            
            // Login
            try {
                User user = userService.authenticate(this.getValue("username"), this.getValue("password"));
                FacesContext.getCurrentInstance().getExternalContext().getSessionMap().put("user", user);
            }
            catch (Exception ex) {
                 
                try {
                    context.redirect("login-register.xhtml");
                } catch (IOException ex2) {
                    Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
            
            // Redirect
            try {
                context.redirect("index.xhtml");
            } catch (IOException ex) {
                Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
            }
            
            return null; //TODO
        }
 
        return errors;
    }
    
}
